MODULE-STARTER(1p)

NAME
module-starter - creates a skeleton module distribution

VERSION
version 1.80

SYNOPSIS
module-starter [options]

Options:

    --module=module  Module name (required, repeatable)
    --distro=name    Distribution name (optional)
    --dir=dirname    Directory name to create new module in (optional)

    --builder=module Build with 'ExtUtils::MakeMaker' or 'Module::Build'
    --eumm           Same as --builder=ExtUtils::MakeMaker
    --mb             Same as --builder=Module::Build
    --mi             Same as --builder=Module::Install (discouraged)

    --author=name    Author's name (taken from getpwuid if not provided)
                     and Email address ( taken from $ENV{EMAIL} if Author's name is not provided )
                     Format: Author Name <author_email@domain.tld>
                     This option can be supplied multiple times for projects
                     that have multiple authors.
    --github=login   Create links to the author's GitHub issue tracker

    --ignores=type   Ignore type files to include (repeatable)
    --license=type   License under which the module will be distributed
                     (default is artistic2)
    --genlicense     Generate LICENSE file according to specified license
    --minperl=ver    Minimum Perl version required (optional;
                     default is 5.008003)

    --fatalize       Generate code that causes all warnings to be fatal with:
                     use warnings FATAL => 'all'

    --verbose        Print progress messages while working
    --force          Delete pre-existing files if needed

    --help           Show this message

Available Licenses:

    perl, artistic, artistic2, mit, mozilla, mozilla2, bsd, freebsd, cc0,
    gpl, lgpl, gpl3, lgpl3, agpl3, apache, qpl

You may also specify any Software::License subclass or CPAN Meta Spec license string.

Available Ignore Types:

    cvs, git, hg, manifest, generic
    (NOTE: If manifest is included, the MANIFEST file will be skipped
    and only a MANIFEST.SKIP file will be included.)

Example:

    module-starter --module=Foo::Bar,Foo::Bat \
        --author="Andy Lester <andy@petdance.com>"

    module-starter --module=Foo::Bar,Foo::Bat \
        --author="Andy Lester <andy@petdance.com>" \
        --author="Sawyer X <sawyerx@cpan.org>"

DESCRIPTION
"module-starter" is a command-line interface to Module::Starter, which it uses to perform all the work of creating distributions. An alternate backend for "module-starter" can be specified with the "--class" option. Plugins to the standard Module::Starter module can be specified with one or more "--plugin" options.

If no directory name is supplied, the distribution name will be used for the directory. If no distribution name is supplied, the first listed module name will be used as the distribution name.

Multiple --builder options may be supplied to produce the files for multiple builders.

CONFIGURATION
module-starter will look for a configuration file before reading its command line parameters. The default location is "$HOME/.module-starter/config" but if the MODULE_STARTER_DIR environment variable is set, module-starter will look for "config" in that directory.

The configuration file is just a list of names and values, separated by colons. Values that take lists are just space separated. Note that the "--ignores" command line parameter corresponds to the "ignores_type" configuration file entry. A sample configuration file might read:

 author: Ricardo SIGNES <rjbs@cpan.org>
 ignores_type: git
 plugins: Module::Starter::Simple Module::Starter::Plugin::XYZ
 xyz_option: red green blue

This format may become more elaborate in the future, but a file of this type should remain valid.